----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    01:31:02 10/02/2014 
-- Design Name: 
-- Module Name:    compara_salidas - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity compara_salidas is
  Port ( 
   data_gold : in  std_logic_vector (0 to 63);
   data_prueba : in  std_logic_vector (0 to 63);
   clk : in  std_logic;
   rst : in  std_logic;
   rdy_outkey : out std_logic;
   ready : in  std_logic;
   rdy : out  std_logic
	);
end compara_salidas;

architecture Behavioral of compara_salidas is

  signal rdy_key , p_rdy_key , rdy_comp, p_rdy_comp : std_logic;

begin

  generador :process(ready , data_gold , data_prueba)     --generador de claves , funcionando como un contador de 
  begin  
    p_rdy_key <= rdy_key;
    p_rdy_comp <= rdy_comp;
    
    if ( ready = '1') then
      if( data_gold = data_prueba) then
        p_rdy_key <= '1';
      else
        p_rdy_comp <= '1';   
      end if;
    else
      p_rdy_comp <= '0';   
    end if;
    
  end process;
  
  sinc:process(rst ,clk)
  begin
    if(rst ='1')then
      rdy_comp <= '0';
      rdy_key <= '0';
    elsif(clk = '1' and clk'event)then
      rdy_comp <= p_rdy_comp;
      rdy_key <= p_rdy_key;
    end if;
    
  end process;

  rdy_outkey <= rdy_key;
  rdy <= rdy_comp;

end Behavioral;




