----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:43:55 10/01/2014 
-- Design Name: 
-- Module Name:    generator_bits_inkey - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity generator_bits_inkey is

  generic(Valsat:integer:=255 );

  port( 
   inkey : in  std_logic_vector (0 to 63);
   ready_subkey_round16 : in  std_logic;
   ready_comp : in  std_logic;
   rdy_key_generated :out std_logic;
   clk : in  std_logic;
   rst : in  std_logic;
   outkey_generated : out  std_logic_vector (0 to 63)
	);
end generator_bits_inkey;

architecture Behavioral of generator_bits_inkey is

  signal bits_u, p_bits_u : std_logic_vector (0 to 7);
  signal sat, p_sat : std_logic;
  signal p_rdy_key_generated : std_logic;

begin

  generador :process(ready_subkey_round16 , bits_u, ready_comp)     --generador de claves , funcionando como un contador de 
  begin	
    if (ready_subkey_round16 ='1')  then
      p_bits_u <= (others => '0');
      p_rdy_key_generated <= '1';
    elsif (ready_comp= '1') then
      if (bits_u = Valsat ) then
        p_bits_u <= (others => '0');
        p_rdy_key_generated <= '0';
      else
        p_bits_u <= bits_u + 1;
        p_rdy_key_generated <= '1';
      end if;
    else
      p_bits_u <= bits_u;
      p_rdy_key_generated <= '0';
    end if;
    
  end process;
  
  sinc:process(rst ,clk)
  begin
    if(rst ='1')then
      bits_u <= (others => '0');	
      rdy_key_generated <= '0';
    elsif(clk = '1' and clk'event)then
      bits_u <= p_bits_u;
      rdy_key_generated <= p_rdy_key_generated;
    end if;
    
  end process;
  
  outkey_generated <= inkey(0 to 12) & bits_u(0 to 1) & inkey(15 to 17) & bits_u(2 to 3) & 
                      inkey(20 to 49) & bits_u(4) & inkey(51 to 52) & bits_u(5) & 
                      inkey(54 to 56) & bits_u(6) & inkey(58) & bits_u(7) & inkey (60 to 63);
  
end Behavioral;


