----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:30:19 08/08/2014 
-- Design Name: 
-- Module Name:    generator_plaintext - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity generator_plaintext is
  port ( 
   in_plaintext : in  std_logic_vector (0 to 63);
   clk : in  std_logic;
   rst : in  std_logic;
   ready : in  std_logic;
   ready2 : in  std_logic;
   habilita : in  std_logic;
   rdy : out  std_logic;
   numero_ataques : out std_logic_vector (0 to 3);
   out_plaintext : out  std_logic_vector (0 to 63)
	);
end generator_plaintext;

architecture Behavioral of generator_plaintext is

  type estado is (inicio , generador_texto );
  signal estado_actual , estado_siguiente : estado;
  signal p_rdy : std_logic;		
  signal out_text , p_out_text : std_logic_vector (0 to 63);
  signal n_ataques , p_n_ataques : std_logic_vector (0 to 3);	

begin

  generator: process (estado_actual, in_plaintext, out_text, habilita, ready, ready2, n_ataques)

  begin
  
    out_plaintext <= out_text;
    p_out_text <= out_text;
    p_n_ataques <= n_ataques;
    numero_ataques <= n_ataques;
    
    case estado_actual is 
      
      when inicio =>
        p_rdy <= '0';
        
        if (habilita = '1') then
          p_out_text <= in_plaintext;
          estado_siguiente <= generador_texto;
        elsif ( ready = '1') then
          estado_siguiente <= generador_texto;
        elsif ( ready2 = '1') then
          estado_siguiente <= generador_texto;
          p_n_ataques <= (others => '0');
        else
          estado_siguiente <= inicio;	
        end if;
	
      when generador_texto =>
        
        p_out_text <= out_text(63) & out_text(0 to 62);
        p_rdy <= '1';
        p_n_ataques <= n_ataques + 1;
        estado_siguiente <= inicio;
        
      when others =>
        estado_siguiente <= inicio;
    end case ;

  end process ;

  sinc:process(rst ,clk)
  begin
    if(rst ='1')then
      estado_actual <= inicio;
      out_text <= (others => '0');
      n_ataques <= (others => '0');
    elsif(clk = '1' and clk'event)then 
      estado_actual <= estado_siguiente;
      out_text	<= p_out_text;
      rdy <= p_rdy;
      n_ataques <= p_n_ataques;
      
    end if;
    
  end process;

end Behavioral;

