--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   20:43:20 08/09/2014
-- Design Name:   
-- Module Name:   C:/Users/usuario/Desktop/proyectos vhdl (xilinx)/generador_clave_completo/TB_sistema_completo.vhd
-- Project Name:  generador_clave_completo
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sistema_completo
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.math_real.all;   -- for UNIFORM, TRUNC functions
use ieee.numeric_std.all; -- for TO_UNSIGNED function

entity TB_sistema_completo IS
end TB_sistema_completo;

architecture behavior OF TB_sistema_completo IS 
  
 
  component sistema_completo
    port(
      in_plaintext : in  std_logic_vector(0 to 63);  
      habilita : in  std_logic;	 
      rst : in  std_logic;	 
      clk : in  std_logic;		
      decipher : in  std_logic;	
      rdy_outkey : out std_logic;	
      outkey  : out std_logic_vector(0 to 63); --clave final de salida obtenida
      inkey : in   std_logic_vector (0 to 63);	--clave de entrada
		pruebas_aleatorias : in  std_logic;
		error	: in  std_logic_vector (0 to 31);
		procesos_total : out  std_logic_vector (0 to 9);
		n_ataques_total : out  std_logic_vector (0 to 14)
      );
  end component;
  
  --Inputs
  signal in_plaintext : std_logic_vector(0 to 63) := (others => '0');
  signal habilita : std_logic := '0';
  signal rst :  std_logic := '1';
  signal clk : std_logic := '0';
  signal decipher : std_logic := '0';
  signal inkey : std_logic_vector(0 to 63) := (others => '0');
  signal pruebas_aleatorias : std_logic;
  signal error : std_logic_vector (0 to 31);
  

  --Outputs
  signal outkey : std_logic_vector(0 to 63);
  signal rdy_outkey : std_logic;
  signal procesos_total : std_logic_vector (0 to 9);
  signal n_ataques_total : std_logic_vector (0 to 14);

  -- Clock period definitions
  constant clk_period : time := 10 ns;
  signal stimulus1 , stimulus2 : std_logic_vector (0 to 15);
  
begin
  
  -- Instantiate the Unit Under Test (UUT)
  uut: sistema_completo port map (
    in_plaintext => in_plaintext,
    habilita => habilita,
    rst => rst,
    clk => clk,
    decipher => decipher,
    rdy_outkey => rdy_outkey,
    outkey => outkey,
    inkey => inkey,
	 pruebas_aleatorias => pruebas_aleatorias,
	 error => error,
	 procesos_total => procesos_total,
	 n_ataques_total => n_ataques_total
    );

 ------------------------------------------------------
  clk_process :process
  begin
    clk <= '0';
    wait for clk_period/2;
    clk <= '1';
    wait for clk_period/2;
  end process;
  
 ------------------------------------------------------
  stim_proc: process
  begin		
    wait for 100 ns;	
    rst <= '1';
    decipher <= '0';
    wait until clk = '0';
    rst <= '0';
    wait for 5 ns; 
    in_plaintext <= x"c53a69e51dc80ff9";  
    inkey <=x"192ca36f47ea3d10";
    habilita <= '1';
	 pruebas_aleatorias <= '1';
    wait for 10 ns;
    habilita <= '0';		
    wait for clk_period*10;
    wait; 
  end process;
--------- Generador de 16 bits aleatorios -----------------------
-----Cdigo procedente de: http://www.markharvey.info/vhdl/rnd/rnd.html----
  rng1: PROCESS
    VARIABLE seed1: positive := 349;
    VARIABLE seed2: positive := 82346;       -- Seed values for random generator
    VARIABLE rand: real;                     -- Random real-number value in range 0 to 1.0
    VARIABLE int_rand: integer;              -- Random integer value in range 0..65535
    VARIABLE stim1: std_logic_vector(0 to 15);  -- Random 16-bit stimulus
  BEGIN
    wait for 100 ns;
    UNIFORM(seed1, seed2, rand);                                 -- generate random number
    int_rand := INTEGER(TRUNC(rand*65536.0));                      -- rescale to 0..65536, find integer part
    stim1 := std_logic_vector(to_unsigned(int_rand, stim1'LENGTH));  -- convert to std_logic_vector
    stimulus1 <= stim1;
  end process;
  
--------- Generador de 16 bits aleatorios -----------------------
  rng2: PROCESS											
    VARIABLE seed1: positive := 39;
    VARIABLE seed2: positive := 846;            
    VARIABLE rand: real;                        
    VARIABLE int_rand: integer;                 
    VARIABLE stim2: std_logic_vector(0 to 15);  
  BEGIN
    wait for 100 ns;
    UNIFORM(seed1, seed2, rand);                                   
    int_rand := INTEGER(TRUNC(rand*65536.0));                      
    stim2 := std_logic_vector(to_unsigned(int_rand, stim2'LENGTH));  
    stimulus2 <= stim2;
  end process;
  
--Error de 32 bits aleatorio usado para hacer un barrido con multiples procesos de obtencion de clave

  error <= stimulus1 & stimulus2;  

end;
