----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:06:12 04/28/2014 
-- Design Name: 
-- Module Name:    key_generator - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity key_generator IS

  generic(Valsat:integer:=63 );

  port( 
    outkey : out  std_logic_vector (0 to 5);
    fin_key : out  std_logic;
    habilita : in  std_logic;
    clk : in  std_logic;
    rst : in  std_logic
    );
	 
end key_generator ;

architecture Behavioral of key_generator is

  signal key, p_key: std_logic_vector (0 to 5);
  signal sat , p_sat : std_logic;

begin

  generador :process(habilita , key)     --generador de claves , funcionando como un contador de 6 bits 
  begin
    
    if (key = Valsat ) then
      p_sat <= '1';
      p_key <= (others => '0');   
    elsif ( habilita = '1')  then
      p_key <= key + 1;
      p_sat <= '0';   
    else
      p_key <= (others => '0');
      p_sat <= '0';
    end if;
    
  end process;
  
  sinc:process(rst ,clk)
  begin
    if(rst ='1')then
      key <= (others => '0');
      sat <= '0';
    elsif(clk = '1' and clk'event)then
      key <= p_key;
      sat <= p_sat;
    end if;
    
  end process;
  
  outkey <= key;
  fin_key <= sat;

end Behavioral;

